// 
//  openmary.h
//  
//  Author:
//       Jacky Alcine <jackyalcine@gmail.com>
//	 Daniel Bugl <Daniel.Bugl@gmail.com>
//  
//  Copyright (c) 2011 
// 
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
// 
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
// 
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
//  --> View more about this project at https://wiki.ubuntu.com/SpeechControl <--
//
#ifndef __MAIN_H__
#define __MAIN_H__

#include <iostream>
#include <string>
#include <cstdarg>
#include <curl/curl.h>

using namespace std;

using std::string;

namespace openMary {
	enum OPENMARY_REQUEST {
		OPENMARY_VERSION = 0,
		OPENMARY_DATATYPES,
		OPENMARY_VOICES,
		OPENMARY_EXAMPLETEXT,
		OPENMARY_FEATURES,
		OPENMARY_AUDIOFORMATS,
		OPENMARY_VOCALIZATIONS,
		OPENMARY_PROCESS
	};
	
	class Engine {				
		private:			
			CURL *curlHandle;
			string _maryuri;
					
			const int getHttpNumber(string );
			const string getHttpString(string , string = "");
			void getHttpFile(string , string );
			
		public:
			Engine();
			~Engine();
			
			void jumpStart();
			void start();
			void test();
			void setMaryUri(string );
			const string doRequest(OPENMARY_REQUEST , ... );
			
			const bool isActive();
			const string getVersion();
			const string getMaryURI();
	};
}

#endif

